@ECHO ON
@ECHO PicoBlaze C Compiler (c) 2008-2011, Brno University of Technology, krivka@fit.vutbr.cz
@ECHO Usage: "pbcc.bat source.c [kcpsm3|pblazeide] [pause]"

@REM Compilation System - Batch Configuration
@REM Paths from the executing directory to directories of required tools
@SET SDCC_PATH="..\sdcc\bin"
@SET ASM_PATH="..\KCPSM3\Assembler"
@SET SIMUL_PATH="..\pBlazeIDE"
@REM Command-line environment - cygwin or cmd (for Windows command-line)
@SET CMDENV="cygwin"

@REM Compilation System - Initial values
@SET STARTING_PATH=%CD%
@SET FILENAMEEXT=%1
@SET FILENAME=%FILENAMEEXT:~0,-2%
@SET FILEEXT=%FILENAMEEXT:~-2%
@SET PARPAUSE=0 
@SET PARDIALECT=
@REM Make the paths absolute, not relative with the STARTING_PATH
@cd %STARTING_PATH%
@cd %SDCC_PATH%
@SET SDCC_PATH=%CD%
@cd %STARTING_PATH%
@cd %ASM_PATH%
@SET ASM_PATH=%CD%
@cd %STARTING_PATH%
@cd %SIMUL_PATH%
@SET SIMUL_PATH=%CD%
@cd %STARTING_PATH%

:checkparams
@IF NOT EXIST %1 GOTO badfilename
@IF "%FILEEXT%" NEQ ".c" GOTO badfileext
@IF "%2"=="kcpsm3" SET PARDIALECT=kcpsm3
@IF "%2"=="pblazeide" SET PARDIALECT=pblazeide
@IF "%2"=="pause" SET PARPAUSE=1
@IF "%3"=="pause" SET PARPAUSE=1
@IF "%3"=="kcpsm3" IF "%PARDIALECT%"=="" (SET PARDIALECT=kcpsm3) ELSE (GOTO badparam)
@IF "%3"=="pblazeide" IF "%PARDIALECT%"=="" (SET PARDIALECT=pblazeide) ELSE (GOTO badparam)
@IF "%PARDIALECT%"=="" SET PARDIALECT=kcpsm3

@ECHO Processing C source (%1) by PBCCv2 (SDCC 3.0.1 with pblaze port)...
@ECHO Used parameters: dialect=%PARDIALECT% and pause=%PARPAUSE%

:start
@ECHO Preparing %1 for processing...
@cd %STARTING_PATH% 
@copy %1 %SDCC_PATH%\%1
@cd %SDCC_PATH%
@IF EXIST %FILENAME%.psm @DEL %FILENAME%.psm
@IF %CMDENV%=="cygwin" @call sdcc-cygwin.bat %1 %PARDIALECT%
@IF %CMDENV%=="cmd" @call sdcc-cmd.bat %1 %PARDIALECT%
@REM @call sdcc-cygwin.bat %1
@IF NOT EXIST %FILENAME%.psm GOTO badsdcc 
@IF "%PARPAUSE%"=="1"  @pause 

@IF "%PARDIALECT%"=="kcpsm3" GOTO kcpsm3
@IF "%PARDIALECT%"=="pblazeide" GOTO pblazeide
@GOTO badparams

:kcpsm3
@ECHO Preparing %FILENAME%.psm -> %ASM_PATH%\%FILENAME%.psm for processing...
@move /Y %FILENAME%.psm %ASM_PATH%\%FILENAME%.psm
@IF "%PARPAUSE%"=="1"  @pause

@ECHO Translating assembler code to HEX and VHDL (KCPSM3)...
@cd %ASM_PATH%
@IF EXIST %FILENAME%.FMT @DEL %FILENAME%.FMT
@IF EXIST %FILENAME%.LOG @DEL %FILENAME%.LOG
@IF EXIST %FILENAME%.COE @DEL %FILENAME%.COE
@IF EXIST %FILENAME%.VHD @DEL %FILENAME%.VHD
@IF EXIST %FILENAME%.V @DEL %FILENAME%.V
@IF EXIST %FILENAME%.M @DEL %FILENAME%.M
@IF EXIST %FILENAME%.DEC @DEL %FILENAME%.DEC
@IF EXIST %FILENAME%.MEM @DEL %FILENAME%.MEM
@IF EXIST PASS1.DAT @DEL PASS1.DAT
@IF EXIST PASS2.DAT @DEL PASS2.DAT
@IF EXIST CONSTANT.TXT @DEL CONSTANT.TXT
@IF EXIST PASS3.DAT @DEL PASS3.DAT
@IF EXIST LABELS.TXT @DEL LABELS.TXT
@IF EXIST PASS4.DAT @DEL PASS4.DAT
@IF EXIST PASS5.DAT @DEL PASS5.DAT
                                                                                                  
@KCPSM3.EXE %FILENAME%.psm

@IF NOT EXIST %FILENAME%.hex GOTO badasm 
@ECHO Preparing the resulting file %FILENAME%.hex -> %STARTING_PATH%\%FILENAME%.hex...
@move /Y %FILENAME%.hex %STARTING_PATH%\%FILENAME%.hex
@cd %STARTING_PATH%
@ECHO -------------------------------
@ECHO The compilation process of %1 COMPLETED!
@GOTO end

:pblazeide
@ECHO Preparing %FILENAME%.psm -> %SIMUL_PATH%\%FILENAME%.psm for simulation...
@copy /Y %FILENAME%.psm %STARTING_PATH%\%FILENAME%.psm
@move /Y %FILENAME%.psm %SIMUL_PATH%\%FILENAME%.psm
@ECHO -------------------------------
@ECHO The compilation process of %1 COMPLETED!
@GOTO end


@REM Error Messages
:badparams
@ECHO Bad parameters (%*)! See usage instructions.
@GOTO end
:badfilename
@ECHO Bad filename %1!
@GOTO end
:badfileext
@ECHO Bad filename extension (%FILEEXT%). Only ".c" supported!
@GOTO end
:badsdcc
@ECHO The compilation TERMINATED: Error in C source (%1). See SDCC error messages.
@GOTO end 
:badasm
@ECHO The compilation TERMINATED: Error in PSM -> HEX+VHDL proces (%FILENAME%.psm). See errors from KCPSM3.
@GOTO end

:end
@cd %STARTING_PATH%